# -*- coding: utf-8 -*-
# <nbformat>2</nbformat>

# <codecell>

import numpy as np
import pandas

import zickle
import stable
import asmparse

WORKING = zickle.load('working_unified.dat.gz')
ACTIVE  = zickle.load('active_unified.dat.gz')

# <codecell>

WORKING.keys()

# <codecell>

import re
re_prefunc_bb = re.compile(r'^[^:]*:(.*)$')
def strip_prefunc(bb_name):
    if len(bb_name) == 0:
        return ''
    return re_prefunc_bb.match(bb_name).group(1)
strip_prefunc('new_transactions:new_transactions:0')

# <codecell>

pandas.set_printoptions?
from IPython.core.display import HTML

# <codecell>

reload(stable)
reload(asmparse)
import pprint
def analyze_app(name):
    active_prof  = ACTIVE[name]['profiles']
    working_prof = WORKING[name]['profiles']
    asm_file = ACTIVE[name]['asm_file']
    asm_df = asmparse.codepoints_dataframe(asm_file)
    df = stable.unstable_contending_block(active_prof, working_prof)
    df.index = map(strip_prefunc, df.index)
    merged = pandas.merge(asm_df, df, left_on='bb', right_index=True)
    merged = merged.reindex(columns=['file', 'line', 'col', 'bb', 'contention', 'active_instability', 'working_instability'])
    merged = merged.sort(['file', 'line', 'col'])
    return merged

df = analyze_app('BankAccount.res')
HTML(df.to_html())

# <codecell>

asmdf = asmparse.sorted_codepoints(ACTIVE['BankAccount.res']['asm_file'])

# <codecell>


