import profile
import numpy as np
import pandas
import sklearn.mixture
import sklearn.cluster
import sys

# Model selection

# backport from git
def gmm_bic(self, X):
    return (- 2 * self.score(X).sum() +
            self._n_parameters() * np.log(X.shape[0]))
# Monkey patch
sklearn.mixture.GMM.bic = gmm_bic

def gmm__n_parameters(self):
    """Return the number of free parameters in the model."""
    ndim = self.means.shape[1]
    if self.cvtype == 'full':
        cov_params = self.n_components * ndim * (ndim + 1) / 2.
    elif self.cvtype == 'diag':
        cov_params = self.n_components * ndim
    elif self.cvtype == 'tied':
        cov_params = ndim * (ndim + 1) / 2.
    elif self.cvtype == 'spherical':
        cov_params = self.n_components
    mean_params = ndim * self.n_components
    return int(cov_params + mean_params + self.n_components - 1)
sklearn.mixture.GMM._n_parameters = gmm__n_parameters

def gmm_cross_validate(profile, kmin=1, kmax=50):
    def model(k):
        model = sklearn.mixture.GMM(k, 'full')
        model.fit(data)
        print "n = %d; bic = %g"%(k, model.bic(data))
        return model

    return min((model(k) for k in xrange(kmin, kmax)),
                key=lambda m: m.bic(data))

def dbscan(profile):
    db = sklearn.mixture.DBSCAN().fit(data, eps=10, min_samples=20)

if __name__ == "__main__":
    prof = profile.load_profile(sys.argv[1])
    data = prof.astype('float64')
    print data.shape
    model = gmm_cross_validate(data)
    print "%d clusters minimized the BIC. Cluster means: "%(model.n_components)
    print model.means
    print "Mixing coefficients:"
    print model.weights

