The Experiment Specification
===

## Filesystem Representation
Every new type of experiment must generate a directory with the following
structure.

An experiment contains the raw profile output of several applications.
The files are stored in a common directory, generated by a script such
as experiment.sh in the parsec bin directory.

Each _application_ gets its own subdirectory.

To run an experiment, each application is recompiled immediately before
its run.

Within each application subdirectory resides LOG and ERRLOG files. The
experiment runner is responsible for redirecting during the compilation
and running to these appropriate files.

Each application must run for several trials. Each run outputs a profile
n.out, where n is the trial number.

Sometimes, extraneous programs will run during the compilation
that also generate profiles. These profiles shall reside in the
profiles_from_compile subdirectory.

The uninstrumented assembly file WITH DEBUG SYMBOLS corresponding to
the executable that generated the profile outputs shall reside in the
application directory, with a .s suffix. Since a compilation can produce
multiple executables and the build system may not know which executable is
finally invoked, there can be extraneous assembly files. In that case,
the analysis script must automatically detect the correct file. One
method to do so is to match basic block names from the profile to the
assembly files. It is guaranteed that

Finally, the user shall ensure that the experiment is free of errors. That
is, the subsequent analysis steps will ignore ERRLOG files, so the
operator must attend to them before moving on.

Here is an example directory structure, for a parsec experiment:

## Database Representation
The collate.py script will generate a database from a filesystem
representation of an experiment. It will contain all of the data,
but in an easy-to-access format for subsequent analysis with Python
scripts.


