import argparse
import profile
import numpy as np
from itertools import izip

parser = argparse.ArgumentParser(description='Analyze the mixed blocks.')
parser.add_argument('profile', help='the .out file generated')

if __name__ == "__main__":
    args = parser.parse_args()
    prof = profile.load_profile(args.profile)

    prof = prof.astype(float)
    # Normalize
    prof_norm = prof / prof.sum()
    log_p = np.nan_to_num(np.log(prof_norm.as_matrix()))
    rows, _ = log_p.shape
    entropy = np.zeros(rows)

    for i, (p, lp) in enumerate(izip(prof.as_matrix(), log_p)):
        entropy[i] = np.dot(p, lp)
    prof['entropy'] = entropy
    print prof.sort(column='entropy', ascending=True)

#    rows, _ = log_prof_norm.shape
#    entropy = np.zeros(rows)
#    for i, (lp, p) in enumerate(izip(log_prof_norm, prof_norm.as_matrix())):
#        entropy[i] = np.dot(lp, p)
#    print entropy.shape
#    prof['entropy'] = entropy
#    print entropy

