#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#define NITERS 100

static pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;
static int j;

typedef void *start_routine_t(void *);

void busyprint() {
  int i;
  pthread_t self = pthread_self();
  for (i = 0; i < NITERS; i++) {
    pthread_mutex_lock(&lock);
    j++;
    pthread_mutex_unlock(&lock);
  }
  printf("[%lu] mid: j = %d\n", self, j);
  for (i = 0; i < NITERS; i++) {
    pthread_mutex_lock(&lock);
    j++;
    pthread_mutex_unlock(&lock);
  }
  printf("[%lu] end: j = %d\n", self, j);
}

int main(int argc, char **argv) {
  if (argc < 2) {
    fprintf(stderr, "Usage: %s NTHREADS\n", argv[0]);
    return 1;
  }

  int nthreads = atoi(argv[1]);
  if (nthreads <= 0) {
    fprintf(stderr, "Error: NTHREADS must be positive.\n");
    return 2;
  }
  int i;
  pthread_t *threads = malloc(nthreads * sizeof(pthread_t));
  for (i = 0; i < nthreads; i++) {
    pthread_create(&threads[i], NULL, (start_routine_t*) busyprint, NULL);
  }

  for (i = 0; i < nthreads; i++) {
    pthread_join(threads[i], NULL);
  }

  return 0;
}

